; Paste a .csd designed for "canonical" Android Csound5 or 6 here
; Of course you must be running Csound6.05+ to handle the HTML5
: For Android OS < 5.0, change the (chnget) *channel names* here
;   and in your .csd from butt1-5 to but1-5 or some other name
; Buttons are trigger only (simple code); they do not process "touch off"
; No trackpad is implemented in this clone

<html>
<head>
<style type="text/css">

.noselect {
	-webkit-user-select: none;
}

input[type='range'] {
	-webkit-appearance: none;
	background-color: silver;
	height: 70%;
	width: 95%;
}
input[type='range']::-webkit-slider-thumb {
	-webkit-appearance: none;
	width: 10px;
	height: 120%;
	background: white;
}

table td {
	text-align: center;
	color: white;
	background-color: teal;
}

.buttons {
	width: 100%;
}        
.buttons td {
	background-color: cadetblue;
}

</style>

</head>
<body>

<div class="noselect">

<b>Csound6 HTML5 GUI Clone</b>
<br><br>

<table>
<colgroup>
  <col width="">
  <col width="100%">
</colgroup>
<tr>
<td>
	<div class="slider_height">
<label for=slider1>Slider1</label>
</div>
</td>
<td>
<input type=range min=0 max=1 value=0 id=slider1 step=0.001 oninput="slider1(value)">
</td>
</tr>
<tr>
<td>
	<div class="slider_height">
<label for=slider2>Slider2</label>
</div>
</td>
<td>
<input type=range min=0 max=1 value=0 id=slider2 step=0.001 oninput="slider2(value)">
</td>
</tr>
<tr>
<td>
	<div class="slider_height">
<label for=slider3>Slider3</label>
</div>
</td>
<td>
<input type=range min=0 max=1 value=0 id=slider3 step=0.001 oninput="slider3(value)">
</td>
</tr>
<tr>
<td>
	<div class="slider_height">
<label for=slider4>Slider4</label>
</div>
</td>
<td>
<input type=range min=0 max=1 value=0 id=slider3 step=0.001 oninput="slider4(value)">
</td>
</tr>
<tr>
<td>
	<div class="slider_height">
<label for=slider5>Slider5</label>
</div>
</td>
<td>
<input type=range min=0 max=1 value=0 id=slider3 step=0.001 oninput="slider5(value)">
</td>
</tr>
</table>

<table class="buttons" style="margin: auto;">
<tr>
<!-- # of maximum characters per label depends on # of buttons per row, here 5 buttons 5 chars --!>
<!-- # of characters of longest string should be the same for each button per row --!>
<td>
<button class="butt_height" onclick="butt1()">Butt1</button>
</td>
<td>
<button class="butt_height" onclick="butt2()">Butt2</button>
</td>
<td>
<button class="butt_height" onclick="butt3()">Butt3</button>
</td>
<td>
<button class="butt_height" onclick="butt4()">Butt4</button>
</td>
<td>
<button class="butt_height" onclick="butt5()">Butt5</button>
</td>
</tr>
</table>

<script>

/* adjust slider/button heights (% of screen) here */
var slider_height_fraction = 0.08;
var button_height_fraction = 0.06;

var screen_height = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
var screen_width = Math.max(document.documentElement.clientWidth, window.innerWidth || 0);
var elements = document.getElementsByClassName("slider_height");
Array.prototype.forEach.call(elements, function(element) {
	element.setAttribute("style", "height: "+ screen_height * slider_height_fraction +"px;");
});
var elements2 = document.getElementsByClassName("butt_height");
Array.prototype.forEach.call(elements2, function(element) {
	element.setAttribute("style", "height: "+ screen_height * button_height_fraction +"px;");
});

function slider1(value) {
	var numberValue = parseFloat(value);
	csound.setControlChannel('slider1', numberValue);
}
function slider2(value) {
	var numberValue = parseFloat(value);
	csound.setControlChannel('slider2', numberValue);
}
function slider3(value) {
	var numberValue = parseFloat(value);
	csound.setControlChannel('slider3', numberValue);
}
function slider4(value) {
	var numberValue = parseFloat(value);
	csound.setControlChannel('slider4', numberValue);
}
function slider5(value) {
	var numberValue = parseFloat(value);
	csound.setControlChannel('slider5', numberValue);
}

function wait() {
        var ms = 30;  
        ms += new Date().getTime();        
        while (new Date() < ms){};
        return;
}

function butt1() {
        csound.setControlChannel('butt1', 1);
        wait();
        csound.setControlChannel('butt1', 0);
}
function butt2() {
        csound.setControlChannel('butt2', 1);
        wait();
        csound.setControlChannel('butt2', 0);
}
function butt3() {
        csound.setControlChannel('butt3', 1);
        wait();
        csound.setControlChannel('butt3', 0);
}
function butt4() {
        csound.setControlChannel('butt4', 1);
        wait();
        csound.setControlChannel('butt4', 0);
}
function butt5() {
        csound.setControlChannel('butt5', 1);
        wait();
        csound.setControlChannel('butt5', 0);
}
	
</script>

</div>
</body>
</html>
