;Example01.csd
<CsoundSynthesizer>
<CsInstruments>

sr = 44100
ksmps = 64
nchnls = 2
0dbfs = 1.0

#include "perc_set.udo"  ;some predefined instruments
#include "synths.udo"

giIndex init 0 ;despite being called index, it is actually a counter.

instr 1
giIndex += 1
iPattern1[] fillarray 1/2, 1/4, 1/6, 1  ;play around with these values
iPattern2[] fillarray 1,   1,   1/4, 1
iPattern3[] fillarray 1/4, 1/2, 1/4, 1/2
iFreqs[]    fillarray 195, 120, 190, 100

kMetro1 metro 1/iPattern1[giIndex % lenarray(iPattern1)] ;Leave these as it is,
kMetro2 metro 1/iPattern2[giIndex % lenarray(iPattern2)] ;but make sure that the
kMetro3 metro 1/iPattern3[giIndex % lenarray(iPattern3)] ;idea of modulo '%' is
kMetro4 metro 1/iPattern1[int(rnd(lenarray(iPattern1)))] ;firmly understood.
                                                                   
schedkwhen kMetro1, 0, 0, "hihat", 0, 0.1  ;play around with p2 and p3 fields
schedkwhen kMetro2, 0, 0, "kick", 0, 0.2
schedkwhen kMetro3, 0, 0, "snare", 1/2, 0.2
schedkwhen kMetro4, 0, 0, "synth", 0, 0.1, iFreqs[giIndex % lenarray(iFreqs)]
endin

instr hihat
aout perc_set -22, "hihat" ;in the perc_set opcode there is defined "hihat"
outs aout, aout            ;but it should not be confused with the instrument
endin                      ;definition of hihat, same goes for kick and snare.

instr kick
aout perc_set -13, "kick"
outs aout, aout
endin

instr snare
;aout perc_set -13, "snare"  ;uncomment and comment snare3 and evaluate.
aout perc_set -13, "snare3"
outs aout, aout
endin

instr synth
;aout phmod -20, p4       ;uncomment and comment sawtooth and evaluate.
aout sawtooth -24, p4
;aout moogvcf2 aout, 300, 0.9  ;adding filters live can be effective.
outs aout, aout
endin

</CsInstruments>
<CsScore>
t 0 120  ;let's choose 120bpm (that will be a fixed tempo)
;Repeating this way
;seems to solve some
;unwanted bugs.
{1000 x
i 1 $x 1
}
</CsScore>
</CsoundSynthesizer>