<Cabbage>
form size(300,200), guirefresh(8), text("Wagon Wheel")
image bounds(100, 40,100,100), shape("ellipse"), colour(0,0,0,0), outlinethickness(3)
image bounds(100,90,100,4), identchannel("spoke1"), shape("rounded")
image bounds(100,90,100,4), identchannel("spoke2"), shape("rounded")
image bounds(100,90,100,4), identchannel("spoke3"), shape("rounded")
image bounds(100,90,100,4), identchannel("spoke4"), shape("rounded")
numberbox bounds( 0,170,150,30), text("Freq. of Rotation"), range(0.01,60,1,1,0.01), channel("freq")
numberbox bounds(150,170,150,30), text("Frames Per Second"), range(1,64,8.5,1,0.01), channel("FPS")
</Cabbage>

<CsoundSynthesizer>

<CsOptions>
-n
</CsOptions>

<CsInstruments>

sr      =       44100
ksmps   =       16
nchnls  =       2
0dbfs   =       1

instr   1
 kfreq  chnget  "freq"        ; read in Cabbage widgets
 kFPS   chnget  "FPS"

 gkRefresh      metro   kFPS  ; refresh rate

 kphs1  phasor  kfreq         ; phase vector defining the rotation of the wheel

 if gkRefresh==1 then         ; only update with a gkRefresh trigger, i.e. a frame
  kphs2 wrap    kphs1+0.125,0,1  ; second radius
  kphs3 wrap    kphs1+0.25,0,1   ; third radius 
  kphs4 wrap    kphs1+0.375,0,1  ; fourth radius

  Smsg  sprintfk        "rotate(%f,50,2)",2 * $M_PI * kphs1 ; create string
        chnset          Smsg, "spoke1"                      ; send string to widget
  Smsg  sprintfk        "rotate(%f,50,2)",2 * $M_PI * kphs2
        chnset          Smsg, "spoke2"  
  Smsg  sprintfk        "rotate(%f,50,2)",2 * $M_PI * kphs3
        chnset          Smsg, "spoke3"  
  Smsg  sprintfk        "rotate(%f,50,2)",2 * $M_PI * kphs4
        chnset          Smsg, "spoke4"
 endif 
endin

</CsInstruments>

<CsScore>
i 1 0 3600
</CsScore>

</CsoundSynthesizer>