<Cabbage>
form size(300,200), guirefresh(16), colour("white")
image bounds(150,0,1,165), colour(200,200,200), shape("sharp")
image bounds(0,0,0,0), widgetarray("bob",12), shape("ellipse"), colour("black")
numberbox bounds(5,170,60,30), text("Time"), channel("time"), range(-100000,10000,0,1,0.01), colour("white"), textcolour("black"), fontcolour("black")
</Cabbage>

<CsoundSynthesizer>

<CsOptions>
-n -dm0
</CsOptions>

<CsInstruments>

sr 	= 	44100
ksmps 	= 	16
nchnls 	= 	2
0dbfs	=	1

instr	1
 gkRefresh	metro	32
endin

instr	2
 iMToPix	init	400				; scaling sizes to pixels
 ix_OS	=	150					; x position offset 
 iRad	=	7					; radius of bob (visual only)
 iInitAngle	=	75				; initial angle from which to swing
 iInitAngle	/=	90				; initial angle in radians
 iSpeed		=	0.3				; speed modulation of the process: 1=normal <1=slowed down etc.
 iDamp		=	0.001				; amount of damping experience by the pendulums
 iL		=	((60/(2*$M_PI*p4))^2)*9.81	; calculate length of pendulum 
 iT	=	2 * $M_PI * sqrt(iL/9.81) * (1/iSpeed)	; period of a pendulum swing - dependent upon pendulum length but not mass
 kamp	init	iInitAngle				; set initial angle
 kamp	=	kamp / (1+(iDamp/kr))			; amplitude of swing, decreased by damping coefficient upon each k-cycle
 kphs	poscil	kamp,1/iT,-1,0.75			; pendulum phase
 ktime	init	0					; initialise elapsed time counter
 if metro:k(8)==1 then					; update elapsed time widget 8 times per second			
  chnset	ktime,"time"				; send new time value to numberbox widget
 endif
 ktime	+=	iSpeed/kr 				; increment time (account for speed modulation)
 Sident	sprintf	"bob_ident%d",p5			
 if gkRefresh==1 then					; if a (graphic) refresh trigger is received...					
  kx_pix	=	sin($M_PI*kphs*0.5)*iL*iMToPix	; use trig to calculate x position for bob  
  ky_pix	=	cos($M_PI*kphs*0.5)*iL*iMToPix	; use trig to calculate y position for bob
  Smsg	sprintfk	"bounds(%d,%d,%d,%d)", kx_pix + ix_OS - (iRad*0.5), ky_pix -(iRad*0.5), iRad, iRad	; generate message for new position of widget
  	chnset		Smsg, Sident			; send new position message to widget
 endif
 if trigger(kphs,0,2)==1 && timeinstk()!=1 then		; if pendulum is crossing the sound trigger line	
  icps	=	cpsmidinn(20+(p5*6.717))		; derive a sound frequency value from the length of the pendulum
  event	"i",3,0,440/icps,icps				; trigger a sound event
 endif
 SKIP:
endin

instr	3	; a simple sound 'ping'
 aenv	expon	1,p3,0.001
 iamp	=	1/octcps(p4)
 asig	poscil	iamp*aenv,p4
 asig	*=	poscil:a(1,300)
 	outs	asig,asig
endin

</CsInstruments>

<CsScore>
i 1 0 3600

i 2 0 3600 49 1
i 2 0 3600 50 2
i 2 0 3600 51 3
i 2 0 3600 52 4
i 2 0 3600 53 5
i 2 0 3600 54 6
i 2 0 3600 55 7
i 2 0 3600 56 8
i 2 0 3600 57 9
i 2 0 3600 58 10
i 2 0 3600 59 11
i 2 0 3600 60 12

</CsScore>

</CsoundSynthesizer>