
<CsoundSynthesizer>
<CsOptions>
csound -g -d -+rtaudio=ALSA -odac:hw:0,0 -b1024 -B16384
;csound -g -+rtaudio=ALSA -o/opt/csound6-git/spline/wavfiles/splines.wav -b1024 -B16384
</CsOptions>
<CsInstruments>

sr=44100
;ksmps = 32
kr=1
nchnls=2
0dbfs = 1

;create globals
;ginum init 44100
ginum init 9
;ivr                la_i_vr_create        irows
givr_vector	   la_i_vr_create	 ginum
givr_eig_vals      la_i_vr_create	 ginum

;imr               la_i_mr_create        irows, icolumns  [, odiagonal]
gimr_matrix	   la_i_mr_create        3, 3
gimr_eig_vecs      la_i_mr_create	 3, 3

;-------------
;CREATE MATRIX
;------------


	instr 1; k fill matrix
krow init 0
kcolumn init 0
kvalue init 20

reset:
  while kcolumn < 3 do
gimr_matrix	la_k_mr_set	krow, kcolumn, kvalue 
 ;printks2 " kcol %f *", kcolumn
 ;printks2 " kval %f *", kvalue
kvalue = kvalue + 1
kcolumn = kcolumn + 1
  od
kcolumn  = 0
krow = krow + 1
if krow < 3 kgoto reset
	endin

	instr 2 ; alter the diagonal of the matrix
;imr             la_i_mr_set   irow, icolumn, ivalue
gimr_matrix	 la_i_mr_set   0, 0, 4
gimr_matrix	 la_i_mr_set   1, 1, 4
gimr_matrix	 la_i_mr_set   2, 2, 4
	endin

	instr 3; print the diagonally altered matrix
prints "\n*** instr 3, diagonally altered matrix***\n"
la_i_print_mr           gimr_matrix
	endin

;----------------------------------
; EIGEN VALS and EIGEN VECTORS

	instr 4; return vector of eigen vals and real matrix of eigen vectors
givr_eig_vals, gimr_eig_vecs  la_i_qr_sym_eigen_mr  gimr_matrix, 0.001 
	endin

	instr 5; print vectr of eigen vals
prints "\n*** instr 4, vector of changed eigen vals***\n"
la_i_print_vr		givr_eig_vals
	endin

	instr 6; print real matrix of eigen vectors
prints "\n*** instr 5, real matrix of changed eigen vectors***\n"
la_i_print_mr		gimr_eig_vecs
	endin

</CsInstruments>
<CsScore>

i1 1  1
i2 3  2
i3 6  2
s
i4 1  2
i5 3  2
i6 6 2
e

</CsScore>
</CsoundSynthesizer>

</CsScore>
</CsoundSynthesizer>
