//http://eigen.tuxfamily.org/dox/GettingStarted.html

//g++ -I /usr/include/eigen3/ eigen3.cpp -o test1


#include <iostream>
#include <Eigen/Dense>
#include </usr/include/eigen3/Eigen/Eigenvalues> 

void eigvals()
{
  const int n = 3;
  Eigen::VectorXcd eivals(n);
  Eigen::MatrixXd m(n, n);
  m <<
    (4), (21), (22), 
    (23), (4), (25),
    (26), (27), (4);
  std::cout << "The values of m are:" << std::endl << m << std::endl;

  eivals = m.eigenvalues();
  std::cout << "The eigenvalues of m are:" << std::endl << eivals << std::endl;
}

void eigvects()
{
  const int n = 3;
  Eigen::MatrixXd m(n, n);
  m <<
    (4), (21), (22), 
    (23), (4), (25),
    (26), (27), (4);
  std::cout << "The values of m are:" << std::endl << m << std::endl;

  Eigen::EigenSolver<Eigen::MatrixXd> es(m);
  std::cout << "The eigenvectors of m are:" << std::endl << es.eigenvectors() << std::endl;
}

int main()
{
eigvals();
eigvects();
}


