

//g++ -I /usr/include/gmm/ gmm_eigen.cpp -o test2

#include <iostream>
#include <gmm.h>
#include <gmm_dense_qr.h>

int main()
{
double tol = 1E-16;
gmm::dense_matrix<double> M(3, 3);
gmm::clear(M);                  // M = 0
M(0,0) = M(1,1) = M(2,2) = 4.0; // diagonal

M(0,1) = 21;
M(0,2) = 22;
M(1,0) = 23;

M(1,2) = 25;
M(2,0) = 26;
M(2,1) = 27;

std::vector<double> eigvals(3);
gmm::clear(eigvals);

gmm::dense_matrix<double> eigvect(3, 3);
gmm::clear(eigvect);                  // eigval = 0.

implicit_qr_algorithm(M, eigvals, eigvect, tol); //eigvals and eigvectors

std::cout << "orig matrix" << std::endl << M << std::endl;
std::cout << "eigvals vector" << std::endl << eigvals << std::endl;
std::cout  << "eigvector matrix" << std::endl << eigvect << std::endl;

}

