
//ComplexEigenSolver
//http://eigen.tuxfamily.org/dox/classEigen_1_1ComplexEigenSolver.html#a5c53421aa899f6214349c62bad5f36f8


//g++ -I /usr/include/eigen3/ eigen_matrixrestore.cpp -o restore1


#include <iostream>
#include <complex>
#include </usr/include/eigen3/Eigen/Eigenvalues> 


void eigsolver()
{

Eigen::MatrixXcf A(4,4);
A <<
	(20), (21), (22), (23),
	(24), (25), (26), (27),
	(28), (29), (30), (31),
	(32), (33), (34), (35);
std::cout << "Here is a random 4x4 matrix, A:" << std::endl << A << std::endl << std::endl;
Eigen::ComplexEigenSolver<Eigen::MatrixXcf> ces;
ces.compute(A);
std::cout << "The eigenvalues of A are:" << std::endl << ces.eigenvalues() << std::endl;
std::cout << "The matrix of eigenvectors, V, is:" << std::endl << ces.eigenvectors() << std::endl << std::endl;
 
std::complex<float> lambda = ces.eigenvalues()[0];
std::cout << "Consider the first eigenvalue, lambda = " << lambda << std::endl;
Eigen::VectorXcf v = ces.eigenvectors().col(0);
std::cout << "If v is the corresponding eigenvector, then lambda * v = " << std::endl << lambda * v << std::endl;
std::cout << "... and A * v = " << std::endl << A * v << std::endl << std::endl;
std::cout << "Finally, V * D * V^(-1) = " << std::endl

<< ces.eigenvectors() * ces.eigenvalues().asDiagonal() * ces.eigenvectors().inverse() << std::endl;

}


int main()
{
eigsolver();

}


