;J.Hearon
<CsoundSynthesizer>
<CsOptions>
csound -g -d -+rtaudio=ALSA -odac:hw:0,0 -b1024 -B16384
;csound -g -+rtaudio=ALSA -o wavfiles/ssb.wav -b1024 -B16384
</CsOptions>
<CsInstruments>

sr=44100
kr=1
nchnls=2
0dbfs = 1

;create globals
ginum init 44100
gipitchshift init 200
givr_sin	   la_i_vr_create  ginum
givr_insig	   la_i_vr_create  ginum
givr_cos	   la_i_vr_create  ginum
givr_mod1	   la_i_vr_create  ginum
givr_mod2	   la_i_vr_create  ginum
givr_hilbertreal   la_i_vr_create  ginum
givr_hilbertimag   la_i_vr_create  ginum
givr_lower	   la_i_vr_create  ginum
givr_upper	   la_i_vr_create  ginum
gitablenum1 ftgen 100, 0, 44100, 7, 0, 44100, 0
gitablenum2 ftgen 200, 0, 44100, 7, 0, 44100, 0
gitablenum3 ftgen 300, 0, 44100, 7, 0, 44100, 0
gitablenum4 ftgen 400, 0, 44100, 7, 0, 44100, 0
gitablenum5 ftgen 500, 0, 44100, 7, 0, 44100, 0
gitablenum6 ftgen 600, 0, 44100, 7, 0, 44100, 0

gavar_complexcarrier1 init 0 ;global arate variable
gareal init 0 ;global arate variable
gaimag init 0 ;global arate variable

;-------------
;INSIG 
;-------------
	instr 1 ; SIMPLE sin(2pif0t) as insig
krow init 0
kvalue init 0
kcntr init 0
itwopi=3.14
icarfreq = 440 

reset:
givr_insig    la_k_vr_set  krow, kvalue
krow = krow+1
kvalue = sin(itwopi*kcntr/(sr/2)*icarfreq)
kcntr = kcntr + 1
if kcntr < ginum kgoto reset
	endin

	instr 2 ; LISTEN SIMPLE Sin insig
prints "\n*** instr 2, simple sin insig***\n"
asig  la_k_a_assign   givr_insig	
  	outs asig, asig
        endin

;-------------
; or alt INSIG
;- a complex sig using buzz
;NOTE: if using complex sig
;play instr 1 and 2 simultaneously from score
;due to use of global avar
;--------------
/*
	instr 1 ;COMLEX SIG as carrier with added partials
kbase = 440
ifn =  1  ; sine wave ftable
knh line p4, p3, p5
gavar_complexcarrier1 buzz 1, kbase, knh, ifn
;outs gavar_complexcarrier1, gavar_complexcarrier1
	endin

	instr 2
; to LISTEN to the complex sin carrier
prints "\n*** instr 2 Complex (buzz) Carrier asig***\n"
givr_insig  la_k_assign_a   gavar_complexcarrier1
outs gavar_complexcarrier1, gavar_complexcarrier1
        endin
*/
;-----------
;; SIN CARRIER + Pitch shift amount
;-----------
	instr 3 ; SIMPLE sin(2pif0t) of t as carrier
;adds a sine signal to global array givr_sinc
krow init 0
kvalue init 0
kcntr init 0
itwopi=3.14
icarfreq = 440 + gipitchshift

reset:
givr_sin    la_k_vr_set  krow, kvalue
krow = krow+1
kvalue = sin(itwopi*kcntr/(sr/2)*icarfreq)
kcntr = kcntr + 1
if kcntr < ginum kgoto reset
	endin

;-----------
;; COS CARRIER + Pitch Shift amount
;-----------
	instr 4 ; SIMPLE cos(2pif0t) of t as carrier
;adds a cosine signal to global array givr_cos
krow init 0
kvalue init 0
kcntr init 0
itwopi=3.14
icarfreq = 440 + gipitchshift

reset:
givr_cos    la_k_vr_set  krow, kvalue
krow = krow+1
kvalue = cos(itwopi*kcntr/(sr/2)*icarfreq)
kcntr = kcntr + 1
if kcntr < ginum kgoto reset
	endin

;-----------
;; HILBERT of INSIG
;-----------
	instr 5 
;hilbert transform of insig
amod  la_k_a_assign   givr_insig
gareal, gaimag hilbert amod
        endin

	instr 6
; listen to output of hilbert
; and assign to givar	  
;prints "\n*** instr 6 Hilbert of insig***\n"
givr_hilbertreal  la_k_assign_a   gareal
givr_hilbertimag  la_k_assign_a   gaimag
;outs gareal, gareal
	endin

;========================
;========================
;-----------
;; MULTIPLICATION of VECTORS
;-----------
/*
see hilbert ex in Csound manual
amod1 = givr_hilbertreal * givr_sin 
amod2 = givr_hilbertimag * givr_cos
then
upshift is
aupshift = (amod1 - amod2) * .7
adownshift = (amod1 + amod2) * .7
outs aupshift, aupshift
*/
;----------------
	instr 9 
;multiplication of vectors; lower sidebands, mod1
givr_mod1	la_i_multiply_vr    givr_cos, givr_hilbertreal
	endin

	instr 10 
;multiplication of vectors; upper sidebands, mod2
givr_mod2	la_i_multiply_vr    givr_sin, givr_hilbertimag
	endin

;-----------
;; SUM and DIFFERENCES
;-----------
	instr 11 
;differences for upshift, removing lower sidebands
givr_upper  la_i_subtract_vr givr_mod1, givr_mod2
	endin

	instr 12
; sum for downshift; removing upper sidebands
givr_lower  la_i_add_vr givr_mod1, givr_mod2
	endin
;-----------
;; Listen to upper and lower sidebands
;-----------
	instr 14
; to listen to the upper sig
prints "\n*** instr 14 Multiplication asig upper***\n"
asig  la_k_a_assign   givr_upper	
  	outs asig * .7, asig * .7
	endin

	instr 15
; to listen to the lower asig
prints "\n*** instr 15 Multiplication asig lower***\n"
asig  la_k_a_assign   givr_lower	
  	outs asig  * .7 , asig * .7 ;to avoid clipping
	endin

;========================
; save files
;========================
	instr 30
;places the global arrays into tables 
gitablenum1                   la_i_t_assign         givr_insig
gitablenum2                   la_i_t_assign         givr_sin
gitablenum3                   la_i_t_assign         givr_cos
gitablenum4                   la_i_t_assign         givr_lower
gitablenum5                   la_i_t_assign         givr_upper
	endin

	instr 31
;saves the tables for plotting
//add your path below, for location to save files
ftsave "/opt/csound6-git/ssb/datfiles/insig.save", 1, 100
ftsave "/opt/csound6-git/ssb/datfiles/sin.save", 1, 200
ftsave "/opt/csound6-git/ssb/datfiles/cos.save", 1, 300
ftsave "/opt/csound6-git/ssb/datfiles/lower.save", 1, 400
ftsave "/opt/csound6-git/ssb/datfiles/upper.save", 1, 500
	endin

</CsInstruments>
<CsScore>
f 1 0 1024 10 1 ;sinewave table

; insig, simple sin
i1  1  1
i2  2  1

;i1  1  1  3  3 ;or complex sin uses Buzz
;i2  1  1

i3  3  1 ;simple sin
i4  5  1 ;simple cos
;hilbert of insig
i5  7  1
i6  7  1
; delay of insg
;i7  9  1
;i8  11  1
s
;multiplication of vectors
i9   1  1
i10  3  1 
;sum and differences
i11  5  1
i12  7  1 
s
i14 1  1  ;listen upper sig
i15 3  1  ;listen lower sig
s
;write tables to disk
i30 1  5
i31 6  5
e
</CsScore>
</CsoundSynthesizer>
