
//J. Hearon
//set your filepath output location, below, line 34
//> g++ -I /usr/include/gmm/ gmm2.cpp -o test2
//then to view file in gnuplot
//> ./mysed.sh
//> gnuplot
//> plot [0:1000] "td_sig.dat" with lines 1 linetype 1; set terminal x11 1;


#include <iostream>
#include <math.h>
#include <iomanip>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <gmm.h>

#define SIZE 44100
#define N 44102
#define TRUE  1
#define FALSE 0
#define MYCHANNELS 2 
typedef int boolean;

using std::cout;
using std::endl;

using namespace std;

//set your path here for the FILE I/O output below
string path("/home/LinearAlgebraInfo/gmm++Stuff");

double sine(double D, double i, double f, int num, double A) 
{
       double pi = 4 * atan(1.0);
       return A * (sin(2 * pi * i / D * f * num));
}

double sawtooth(double D, double i, double f, int num, double A) 
{
       double sawtooth;
return sawtooth  = A * (2 * (double(num)/double(D/f) - (double(floor((double(num)/double(D/f)) + 0.5)))));
}

double square (double D, double i, double f, int num, double A) 
{
       double pi = 4 * atan(1.0);
       double x = sin(2 * pi * i / D * f * num);
       double mysquare;
       return mysquare = A * ((x > 0) - (x < 0));
}

double triangle(double D, double i, double f, int num, double A) 
{	
       double triangle;
       return triangle  = A * (fabs(2 * (double(num)/double(D/f) - (double(floor((double(num)/double(D/f)) + 0.5))))));
}

int main()
{
 //Sound Sample and FFT variables
    double A = 1.0; //amp scaling factor
    double i = 1; 
    double D =44100; //length and time
//  D/SR=SecPrSample, and SecPrSample*F=1 cycle at given
//  Freq. Thus one 1 cycle = D/SmpPrCycle.
//  at 44.1Khz, 44100/44100=1 sec. pr sample.
//  and 1 * 525 = 525 samples pr 1 cycle at
//  that freq. Thus one cycle = 44100/525= 84
//  samples for the given dur(D) and freq(F).
//  See int myksmps below.
    double f = 525; //frequency in Hz. 

string tdSigAppend ("/td_sig.dat");
string tdSigPath = path + tdSigAppend;
FILE *outf2;
outf2=fopen(tdSigPath.c_str(),"w");

std::vector<double> V(N);
gmm::clear(V);

for (int s=0;s<SIZE;s++) {
    V[s] = sawtooth(D, i, f, s, A);  
fprintf(outf2, "%4.20f\n", V[s]);
    }

fclose(outf2);
//std::cout << " V: "  << V << std::endl;


}
